CAL_MODE:
	CALL		Delay_10ms
	BTSS		PT1,CAL_PIN,A
	JMP		CAL_MODE_1
	CALL		SHOWCAL1			;LCDCAL1AܶiJ25XCŮեThermistor
	BCF		FLAG,INTEND,A		;_ȧлxM0
	BCF		INTF1,ADCIF,A
	BSF		INTE1,ADCIE,A
;	BSF		ADCCN1,ENADC,A		;}ADC
CAL_TS_LOOP:
	CALL		CLEAR_EAX
AD_TS_LOOP:
	BTSS		FLAG,INTEND,A		;P_ADCO_ȡH
	JMP		AD_TS_LOOP
	BCF		FLAG,INTEND,A		;_ȧлxM0
	BCF		INTF1,ADCIF,A
	BCF		INTE1,ADCIE,A
;	BCF		ADCCN1,ENADC,A		;ADC
	MVF		HOLDMODE,W,ACCE		;P_32ADCO_íw
	ANDL		0FH
	TFSZ		WREG,ACCE
	JMP		CAL_TS_AD
;-----------------------------------
;GAIN1 = 1F40H * RF_ADX / RS_ADX
;-----------------------------------
	MVL		40H
	MVF		AL,F,A
	MVL		1FH
	MVF		AH,F,A
	CLRF		EAL,A
	CLRF		EAH,A
	MVFF		RF_ADL,BL
	MVFF		RF_ADH,BH
	CLRF		EBL,A
	CLRF		EBH,A
	CALL		32BITMUL32BITU		;EAH|EAL|AH|AL * EBH|EBL|BH|BL ==> EBH|EBL|BH|BL|EAH|EAL|AH|AL
	CALL		EBX_EDX
	CALL		EAX_EBX
	CALL		EDX_EAX
	CLRF		ECH,A
	CLRF		ECL,A
	MVFF		RS_ADH,CH
	MVFF		RS_ADL,CL
	CLRF		EGH,A
	CLRF		EGL,A
	MVFF		RS_ADH,GH
	MVFF		RS_ADL,GL
	CALL		64bitdiv32bitu	;EAH|EAL|AH|AL|EBH|EBL|BH|BL / ECH|ECL|CH|CL ==> EBH|EBL|BH|BL|EAH|EAL|AH|AL
	CALL		64DIV32INF			;|ˤJ			
	MVFF		EAL,TS_GAINH
	MVFF		AH,TS_GAINM
	MVFF		AL,TS_GAINL
	MVL		5AH
	MVF		TS_5A,F,A			;ibŪEEPROMɰwPAP_ThermistorO_gLե
	MVFF		EAL,TSM_GAINH
	MVFF		AH,TSM_GAINM
	MVFF		AL,TSM_GAINL
	MVL		5AH
	MVF		TSM_5A,F,A			;ibŪEEPROMɰwPAP_ThermistorO_gLե
	
	BTSS		PT1,BIT6,A
	JMP		SAVE_TSM
;------------Write EEPROM--------------
	;TS_GAINL ==> EEPROM 00H
	;TS_GAINM ==> EEPROM 01H
	;TS_GAINH ==> EEPROM 02H
	;TS_5A    ==> EEPROM 03H
	MVL		000H           		
	MVF		EEADDRESS,F,ACCE	;EEPROMxsm00H}l   
	MVL		04H									
	MVF		S_REG_EE,F,ACCE		;xs000H,001H,002H,003H
	MVL		0A0H
	MVF		EECNT,F,ACCE		;EEPROMROr
	LDPR		000H,FSR0			;ŧiƾڦa}
	MVL		TS_GAINL			;xsRAM}
	CALL		EEWRBLK			;IsgJl{
	JMP		WRITE_END

SAVE_TSM:
;------------Write EEPROM--------------
	;TS_GAINL ==> EEPROM 08H
	;TS_GAINM ==> EEPROM 09H
	;TS_GAINH ==> EEPROM 0AH
	;TS_5A    ==> EEPROM 0BH
	MVL		008H           		
	MVF		EEADDRESS,F,ACCE	;EEPROMxsm08H}l   
	MVL		04H									
	MVF		S_REG_EE,F,ACCE		;xs008H,009H,00AH,00BH
	MVL		0A0H
	MVF		EECNT,F,ACCE		;EEPROMROr
	LDPR		000H,FSR0			;ŧiƾڦa}
	MVL		TSM_GAINL			;xsRAM}
	CALL		EEWRBLK			;IsgJl{

WRITE_END:	
	CALL		CLEAR_EAX
	BCF		INTF1,ADCIF,A
	BSF		INTE1,ADCIE,A
;	BSF		ADCCN1,ENADC,A		;}ADC
	
SHOW_TS:
	BTSZ		FLAG,INTEND,A		;P__ȬO_
	JMP		DEAL_TS
SHOW_TS_1:
	BTSS		PT1,BIT0,A			;P_O_XThermistorեҦ
	JMP		CAL_OUT
	JMP		SHOW_TS
	
DEAL_TS:
	BCF		INTF1,ADCIF,A
	BCF		INTE1,ADCIE,A
;	BCF		ADCCN1,ENADC,A		;ADC
	BTSZ		FLAG,T_AD,A
	JMP		SHOW_AD_TS
	CALL		TS_TEMPERATURE		;pThermistorqū
	CLRF		EAL
	MVFF		TS_H,AH
	MVFF		TS_L,AL
	CALL		24BITHEXTOBCD		;ҷūBCDXഫ
	MVFF		AL,LCDTEMP1
	MVFF		AH,LCDTEMP2
	MVFF		EAL,LCDTEMP3
	CALL		DISPLAY_TS			;Thermistorqū
	MVL		LCDNUMC
	MVF		LCD0,F,A			;ܶiJThermistorեҦ
	MVL		LCDNUMA
	MVF		LCD1,F,A

DEAL_TS_OUT:	
	MVL		006H
	MVF		NET_CNT,F,ACCE
	MVL		007H
	MVF		ADC_CNT,F,ACCE
	CALL		NET_RFZ	
	CALL		CLEAR_EAX
	BCF		FLAG,INTEND,A		;_ȧлxM0
	BCF		INTF1,ADCIF,A
	BSF		INTE1,ADCIE,A
;	BSF		ADCCN1,ENADC,A		;}ADC
	JMP		SHOW_TS_1			;`
	
SHOW_AD_TS:
	CLRF		EAL
	MVFF		RS_ADH,AH
	MVFF		RS_ADL,AL
	BTSZ		RS_ADH,BIT7,A
	CALL		COMF_EAX_1
	BTSS		RS_ADH,BIT7,A
	BCF		FLAG,SIGN,A
	CALL		24BITHEXTOBCD
	MVFF		AL,LCDTEMP1
	MVFF		AH,LCDTEMP2
	MVFF		EAL,LCDTEMP3
	MVFF		EAH,LCDTEMP4
	CALL		display_AD			;ThermistorX
	JMP		DEAL_TS_OUT
	
CAL_TS_AD:
	MVFF		RS_ADL,AL
	MVFF		RS_ADH,AH
	MVFF		REGI_L,BL
	MVFF		REGI_H,BH
	CALL		16SUB16			;AX - BX ==> AX
	BTSS		STATUS,C,A			;P_۴᪺Ÿ
	CALL		COMF_AX			;D
	MVL		02H
	MVF		BL,F,A
	CLRF		BH,A
	CALL		16SUB16			;AX - BX ==> AX
	BTSZ		STATUS,C,A
	JMP		CAL_TS_NEW
	DCF		HOLDMODE,F,A
	BCF		INTF1,ADCIF,A
	BSF		INTE1,ADCIE,A
;	BSF		ADCCN1,ENADC,A
	JMP		CAL_TS_LOOP
CAL_TS_NEW:
	MVFF		RS_ADH,REGI_H
	MVFF		RS_ADL,REGI_L
	MVL		20H
	MVF		HOLDMODE,F,A
	BCF		INTF1,ADCIF,A
	BSF		INTE1,ADCIE,A
;	BSF		ADCCN1,ENADC,A
	JMP		CAL_TS_LOOP
	
CAL_MODE_1:
	BCF		INTF1,ADCIF,A
	BCF		INTE1,ADCIE,A
;	BCF		ADCCN1,ENADC,A		;ADC
	MVL		10H
	MVF		TIME_CNT,F,A
DELAY2S_LOOP:
	CALL		Delay_100ms
	DCSZ		TIME_CNT,F,A
	JMP		DELAY2S_LOOP
	BTSZ		PT1,CAL_PIN,A
	JMP		CAL_MODE
	CALL		SHOWCAL2			;LCDCAL2AܶiJ37XCؼзū׮եThermopile
	
	BCF		FLAG,INTEND,A		;_ȧлxM0
	BCF		INTF1,ADCIF,A
	BSF		INTE1,ADCIE,A
;	BSF		ADCCN1,ENADC,A		;}ADC
CAL_TP_LOOP:
	CALL		CLEAR_EAX
AD_TP_LOOP:
	BTSS		FLAG,INTEND,A
	JMP		AD_TP_LOOP
	BCF		FLAG,INTEND,A
	BCF		INTF1,ADCIF,A
	BCF		INTE1,ADCIE,A
;	BCF		ADCCN1,ENADC,A
	MVF		HOLDMODE,W,A
	ANDL		0FH
	TFSZ		WREG,A
	JMP		CAL_TP_AD
	
	BSF		KEYFLAG,SETFLAG,A	;}ҥ`ܥؼзū׼лx
	BCF		FLAG,NO_CAL,A
	
	BTSS		PT1,BIT6,A			;P_PT1.6޸}q
	JMP		GAINM
;-------------------------------------------------------------------------------
;dpoҷūT'AMNҷūק@ؼзūסA0XC@ҷū׬dpoq
;-------------------------------------------------------------------------------
	CALL		TS_TEMPERATURE
	CALL		TSV_VOLTAGE
;---------------------------------------------------------
;GAIN2 = 100H * (5B8H - TSV_H|TSV_L) / TP_ADX(37XC,T')
;---------------------------------------------------------
;------------- (5B8H - TSV_H|TSV_L) ---------------
	MVL		05H
	MVF		AH,F,ACCE
	MVL		0B8H
	MVF		AL,F,ACCE
	MVFF		TSV_H,BH
	MVFF		TSV_L,BL
	CALL		16SUB16			; AX-BX = AX
;----------- (5B8H - TSV_H|TSV_L)*100H -------------
	CLRF		EAH
	MVFF		AH,EAL
	MVFF		AL,AH
	CLRF		AL
;--------- (5B8H - TSV_H|TSV_L)*100H/TP_ADX ---------
	CALL		EAX_EBX			;EAX|AX ==> EBX|BX
	CALL		CLEAR_EAX			;oQơGEAH|EAL|AH|AL|EBH|EBL|BH|BL
	CLRF		ECH,A
	CLRF		ECL,A
	MVFF		TP_ADH,CH
	MVFF		TP_ADL,CL
	CLRF		EGH,A
	CLRF		EGL,A
	MVFF		TP_ADH,GH
	MVFF		TP_ADL,GL
	CALL		64bitdiv32bitu	;EAH|EAL|AH|AL|EBH|EBL|BH|BL / ECH|ECL|CH|CL ==> EBH|EBL|BH|BL|EAH|EAL|AH|AL
	CALL		64DIV32INF			;|ˤJ			
	MVFF		EAL,TP_GAINH
	MVFF		AH,TP_GAINM
	MVFF		AL,TP_GAINL
	MVL		5AH
	MVF		TP_5A,F,A			;ibŪEEPROMɰwPAP_ThermopileO_gLե
	
;------------Write EEPROM--------------
	;TP_GAINL ==> EEPROM 04H
	;TP_GAINM ==> EEPROM 05H
	;TP_GAINH ==> EEPROM 06H
	;TP_5A    ==> EEPROM 07H
	MVL		004H           		
	MVF		EEADDRESS,F,ACCE	;EEPROMxsm04H}l   
	MVL		04H									
	MVF		S_REG_EE,F,ACCE		;xs004H,005H,006H,007H
	MVL		0A0H
	MVF		EECNT,F,ACCE		;EEPROMROr
	LDPR		000H,FSR0			;ŧiƾڦa}
	MVL		TP_GAINL			;xsRAM}
	CALL		EEWRBLK			;IsgJl{
	
	CALL		CLEAR_EAX
	BCF		INTF1,ADCIF,A
	BSF		INTE1,ADCIE,A
;	BSF		ADCCN1,ENADC,A		;}ADC	
	
SHOW_TP:
	BTSZ		FLAG,INTEND,A		;P__ȬO_
	JMP		DEAL_TP
SHOW_TP_1:
	BTSS		PT1,BIT0,A			;P_O_XThermopileեҦ
	JMP		CAL_OUT
	JMP		SHOW_TP
	
DEAL_TP:
	BCF		INTF1,ADCIF,A
	BCF		INTE1,ADCIE,A
;	BCF		ADCCN1,ENADC,A		;ADC
	BTSZ		FLAG,T_AD,A
	JMP		SHOW_AD_TP
	CALL		DEAL				;pThermopileqūר
	MVL		LCDNUMC
	MVF		LCD0,F,A			;ܶiJThermopileեҦ
	MVL		LCDNUMB
	MVF		LCD1,F,A
	BCF		INTF1,ADCIF,A
	BCF		INTE1,ADCIE,A
;	BCF		ADCCN1,ENADC,A		;ADC

DEAL_TP_OUT:
	MVL		006H
	MVF		NET_CNT,F,ACCE
	MVL		007H
	MVF		ADC_CNT,F,ACCE
	CALL		NET_RFZ	
	CALL		CLEAR_EAX
	BCF		FLAG,INTEND,A		;_ȧлxM0
	BCF		INTF1,ADCIF,A
	BSF		INTE1,ADCIE,A
;	BSF		ADCCN1,ENADC,A		;}ADC
	JMP		SHOW_TP_1			;`
	
SHOW_AD_TP:
	CLRF		EAL
	MVFF		TP_ADH,AH
	MVFF		TP_ADL,AL
	BTSZ		TP_ADH,BIT7,A
	CALL		COMF_EAX_1
	BTSS		TP_ADH,BIT7,A
	BCF		FLAG,SIGN,A
	CALL		24BITHEXTOBCD
	MVFF		AL,LCDTEMP1
	MVFF		AH,LCDTEMP2
	MVFF		EAL,LCDTEMP3
	MVFF		EAH,LCDTEMP4
	CALL		display_AD			;ThermopileX
	JMP		DEAL_TP_OUT

CAL_TP_AD:
	MVFF		TP_ADL,AL
	MVFF		TP_ADH,AH
	MVFF		REGI_L,BL
	MVFF		REGI_H,BH
	CALL		16SUB16			;AX - BX ==> AX
	BTSS		STATUS,C,A			;P_۴᪺Ÿ
	CALL		COMF_AX			;D
	MVL		02H
	MVF		BL,F,A
	CLRF		BH,A
	CALL		16SUB16			;AX - BX ==> AX
	BTSZ		STATUS,C,A
	JMP		CAL_TP_NEW
	DCF		HOLDMODE,F,A
	BCF		INTF1,ADCIF,A
	BSF		INTE1,ADCIE,A
;	BSF		ADCCN1,ENADC,A
	JMP		CAL_TP_LOOP
CAL_TP_NEW:
	MVFF		TP_ADH,REGI_H
	MVFF		TP_ADL,REGI_L
	MVL		20H
	MVF		HOLDMODE,F,A
	BCF		INTF1,ADCIF,A
	BSF		INTE1,ADCIE,A
;	BSF		ADCCN1,ENADC,A
	JMP		CAL_TP_LOOP

GAINM:
	CALL		TS_TEMPERATURE		;dpThermopileҷū
	CALL		TSV_M
;---------------------------------------------------------
;GAIN2 = 100H * (36CH - TSV_H|TSV_L) / TP_ADX(37XC,T')
;---------------------------------------------------------
;------------- (36CH - TSV_H|TSV_L) ---------------
	MVL		03H
	MVF		AH,F,ACCE
	MVL		06CH
	MVF		AL,F,ACCE
	MVFF		TSV_H,BH
	MVFF		TSV_L,BL
	CALL		16SUB16			; AX-BX = AX
;----------- (36CH - TSV_H|TSV_L)*100H -------------
	CLRF		EAH
	MVFF		AH,EAL
	MVFF		AL,AH
	CLRF		AL
;--------- (36CH - TSV_H|TSV_L)*100H/TP_ADX ---------
	CALL		EAX_EBX			;EAX|AX ==> EBX|BX
	CALL		CLEAR_EAX			;oQơGEAH|EAL|AH|AL|EBH|EBL|BH|BL
	CLRF		ECH,A
	CLRF		ECL,A
	MVFF		TP_ADH,CH
	MVFF		TP_ADL,CL
	CLRF		EGH,A
	CLRF		EGL,A
	MVFF		TP_ADH,GH
	MVFF		TP_ADL,GL
	CALL		64bitdiv32bitu	;EAH|EAL|AH|AL|EBH|EBL|BH|BL / ECH|ECL|CH|CL ==> EBH|EBL|BH|BL|EAH|EAL|AH|AL
	CALL		64DIV32INF			;|ˤJ			
	MVFF		EAL,TPM_GAINH
	MVFF		AH,TPM_GAINM
	MVFF		AL,TPM_GAINL
	MVL		5AH
	MVF		TPM_5A,F,A			;ibŪEEPROMɰwPAP_ThermopileO_gLե
	
;------------Write EEPROM--------------
	;TPM_GAINL ==> EEPROM 0CH
	;TPM_GAINM ==> EEPROM 0DH
	;TPM_GAINH ==> EEPROM 0EH
	;TPM_5A    ==> EEPROM 0FH
	MVL		00CH           		
	MVF		EEADDRESS,F,ACCE	;EEPROMxsm0CH}l   
	MVL		04H									
	MVF		S_REG_EE,F,ACCE		;xs00CH,00DH,00EH,00FH
	MVL		0A0H
	MVF		EECNT,F,ACCE		;EEPROMROr
	LDPR		000H,FSR0			;ŧiƾڦa}
	MVL		TPM_GAINL			;xsRAM}
	CALL		EEWRBLK			;IsgJl{
	
	CALL		CLEAR_EAX
	BCF		INTF1,ADCIF,A
	BSF		INTE1,ADCIE,A
;	BSF		ADCCN1,ENADC,A		;}ADC
	JMP		SHOW_TP

CAL_OUT:
	CALL		Delay_10ms
	BTSS		PT1,BIT0,A
	JMP		CAL_OUT
	BCF		INTF1,ADCIF,A
	BCF		INTE1,ADCIE,A
;	BCF		ADCCN1,ENADC,A		;ADC
	JMP		Main_Pro			;^qҦ
	