DELAY_5ms:
	MVL		2
	MVF		TIMER,F,ACCE
Delay5ms_2:
	MVL		0
Delay5ms_1:
	DCSZ		WREG,F,ACCE
	JMP		Delay5ms_1
	DCSZ		TIMER,F,ACCE
	JMP		Delay5ms_2
	NOP
	RET
	
Delay_10ms:
	MVL		4
	MVF		TIMER,F,A
Delay10ms_2:
	MVL		0
Delay10ms_1:
	DCSZ		WREG,F,A
	JMP		Delay10ms_1
	DCSZ		TIMER,F,A
	JMP		Delay10ms_2
	NOP
	RET
	
Delay_100ms:
	MVL		30H
	MVF		TIMER,F,A
Delay100ms_2:
	MVL		0
Delay100ms_1:
	DCSZ		WREG,F,A
	JMP		Delay100ms_1
	DCSZ		TIMER,F,A
	JMP		Delay100ms_2
	NOP
	RET

Delay_LCD:
	MVL		0FFH
	MVF		timer,F,ACCE
Delay_LCD_2:   
	MVL		0
Delay_LCD_1:   
	DCSZ		WREG,F,ACCE
	JMP		Delay_LCD_1
	DCSZ		TIMER,F,ACCE
	JMP		Delay_LCD_2
	RET

;-------------Clear EAX|AX--------------	
CLEAR_EAX:
	CLRF		AL
	CLRF		AH
	CLRF		EAL
	CLRF		EAH
	RET

;---------------------------------------
;AH|AL + BH|BL ==> AH|AL
16ADD16:
	CLRF		STATUS
	MVF		BL,W,A
	ADDF		AL,F,A
	MVF		BH,W,A
	ADDC		AH,F,A
	RET

;---------------------------------------
;EAX|AX + EBX|BX ==> EAX|AX
32ADD32:
	CLRF		STATUS
	MVF		BL,W,ACCE
	ADDF		AL,F,ACCE
	MVF		BH,W,ACCE
	ADDC		AH,F,ACCE
	MVF		EBL,W,ACCE
	ADDC		EAL,F,ACCE
	MVF		EBH,W,ACCE
	ADDC		EAH,F,ACCE
	RET

;---------------------------------------
;AH|AL - BH|BL ==> AH|AL
16SUB16:
	CLRF		STATUS,ACCE
	MVF		BL,W,ACCE
	SUBF		AL,F,ACCE
	MVF		BH,W,ACCE
	SUBC		AH,F,ACCE
	RET
	
;---------------------------------------
;EAX|AX - EBX|BX ==> EAX|AX
32SUB32:
	CLRF		STATUS,A
	MVF		BL,W,ACCE
	SUBF		AL,F,ACCE
	MVF		BH,W,ACCE
	SUBC  	AH,F,ACCE
	MVF		EBL,W,ACCE
	SUBC  	EAL,F,ACCE	
	MVF		EBH,W,ACCE
	SUBC  	EAH,F,ACCE
	RET

;==============================================
;function:16bitP16bitLŸkB]Qέk^
;inputGAH/ALPBH/BL]AX*BX)
;output:EAH/EAL/AH/AL 
;==============================================
16BITMUL16BITU:
	CLRF		STATUS
	CLRF		EAH
	CLRF		EAL	
	MVF		AH,W,ACCE
	MVF		MUL_REGH,F,ACCE
	MVF		AL,W,ACCE
	MVF		MUL_REGL,F,ACCE
	MVL		010H
	MVF		BUFFER,F,ACCE	;ݭn`쪺ƽᵹbufferHs
LOOP16U:
	BTSZ		BL,0			;P_BH/ĻCO_0
	CALL		ADD2OPRATION	;shեΥ[kBEAH/L+MUL_REGH/LᵹEAH/L
	CALL		RR4F			;ճqEAH/EAL/AH/ALk@AåBBH/BLk@
	DCSZ		BUFFER,F,ACCE	;buffer1P_즸ƬO_
	JMP		LOOP16U		;S~B
	CLRF		MUL_REGH		;B⧹MMUL_REGH/L
	CLRF		MUL_REGL		
	RET
ADD2OPRATION:	
	MVF		MUL_REGL,W,ACCE
	ADDF		EAL,F,ACCE		;MUL_REGH/L+EAH/L->EAH/L
	MVF		MUL_REGH,W,ACCE
	ADDC		EAH,F,ACCE
	RET
RR4F:
	RRFC		EAH,F,ACCE		;C/EAH/EAL/AH/ALk@
	RRFC		EAL,F,ACCE
	RRFC		AH,F,ACCE
	RRFC		AL,F,ACCE
	CLRF		STATUS		;MAHs
	RRFC		BH,F,ACCE		;⭼BH/Lk@
	RRFC		BL,F,ACCE
	CLRF		STATUS		;MAHs
	RET
	
;-----------------------------------------------------
;function:32bitP32bitLŸkB]Qέk^
;inputGEAH/EAL/AH/ALPEBH/EBL/BH/BL]EBX*EAX)
;output:EBH/EBL/BH/BL/EAH/EAL/AH/AL
;-----------------------------------------------------	
32BITMUL32BITU:
	CLRF		STATUS
	CLRF		ECH
	CLRF		ECL
	CLRF		CH
	CLRF		CL
	MVF		EAH,W,ACCE
	MVF		MUL_REGEH,F,ACCE
	MVF		EAL,W,ACCE
	MVF		MUL_REGEL,F,ACCE
	MVF		AH,W,ACCE
	MVF		MUL_REGH,F,ACCE
	MVF		AL,W,ACCE
	MVF		MUL_REGL,F,ACCE
	CLRF		STATUS
	MVL		20H
	MVF		BUFFER,F,ACCE
LOOP32U:
	BTSZ		BL,0
	CALL		ADD4OPRATION
	CALL		RR8F
	DCSZ		BUFFER,F,ACCE
	JMP		LOOP32U
	MVF		ECH,W,ACCE
	MVF		EBH,F,ACCE
	MVF		ECL,W,ACCE
	MVF		EBL,F,ACCE
	MVF		CH,W,ACCE
	MVF		BH,F,ACCE
	MVF		CL,W,ACCE
	MVF		BL,F,ACCE
	CLRF		MUL_REGH
	CLRF		MUL_REGL
	CLRF		MUL_REGEH
	CLRF		MUL_REGEL
	CLRF		ECH
	CLRF		ECL
	CLRF		CH
	CLRF		CL
	RET
ADD4OPRATION:
	MVF		MUL_REGL,W,ACCE
	ADDF		CL,F,ACCE
	MVF		MUL_REGH,W,ACCE
	ADDC		CH,F,ACCE
	MVF		MUL_REGEL,W,ACCE
	ADDC		ECL,F,ACCE
	MVF		MUL_REGEH,W,ACCE
	ADDC		ECH,F,ACCE
	RET
RR8F:
	RRFC		ECH,F,ACCE
	RRFC		ECL,F,ACCE
	RRFC		CH,F,ACCE
	RRFC		CL,F,ACCE
	RRFC		EAH,F,ACCE
	RRFC		EAL,F,ACCE
	RRFC		AH,F,ACCE
	RRFC		AL,F,ACCE
	CLRF		STATUS
	RRFC		EBH,F,ACCE
	RRFC		EBL,F,ACCE
	RRFC		BH,F,ACCE
	RRFC		BL,F,ACCE
	CLRF		STATUS
	RET

;===========================================================
;input: EAH/EAL/AH/AL(Qơ^,CH/CL]ơ^
;output:EAH/EAL/AH/AL(kB⪺ӡ^,DH/DL(kB⪺lơ^ 
;===========================================================
32BITDIV16BITU:				;lƬܶq
	MVL		020H		
	MVF		BUFFER,F,ACCE	;lƲ즸32
	CLRF		DIVH			
	CLRF		DIVL
	CLRF		DIVEL
divloop32_16u:				;Gi찣kB
	CLRF		STATUS
	RLFC		AL,F			;Qƪ4Ӧr`i楪Bz,Ӥ]i楪1				
	RLFC		AH,F
	RLFC		EAL,F
	RLFC		EAH,F
	RLFC		DIVL,F		;QƲXȫOsDIVH/LAýᵹDH/DL
	RLFC		DIVH,F	
	RLFC		DIVEL,F
	MVF		DIVL,W,ACCE		
	MVF		DL,F,ACCE
	MVF		DIVH,W,ACCE
	MVF		DH,F,ACCE
	MVF		DIVEL,W,ACCE
	MVF		EDL,F,ACCE
	CALL		DX_CX			;DH/DLPCH/CLۤ
	BTSS		STATUS,C		;P_o쪺DH/DLO_j󰣼(C1hj^
	JMP		DIVLS32_16U	;EDL/DH/DL<CH/CLP_즸ƬO_Bz
	MVF		DL,W,ACCE
	MVF		DIVL,F,ACCE	;hƪȭsᵹDIVEL/DIVH/DIVL
	MVF		DH,W,ACCE
	MVF		DIVH,F,ACCE
	MVF		EDL,W,ACCE
	MVF		DIVEL,F,ACCE
	INF		AL,F			;j󰣼ơAӹm1۷setb al,0,acce
DIVLS32_16U:				;P_ƾڬO_Bz
	DCSZ		BUFFER,F,ACCE	;즸ƴ1O_0
	JMP		divloop32_16u	;SƾڹBA~iGi찣kB;
	CLRF		STATUS		
	MVF		DIVL,W,ACCE	;OskB⪺lƩDH/DL
	MVF		DL,F,ACCE
	MVF		DIVH,W,ACCE
	MVF		DH,F,ACCE
	RET
DX_CX:					;DH/DL-CH/CLkB
	MVF		CL,W,ACCE
	SUBF		DL,F,ACCE		;۴GOsbDH/DL
	MVF		CH,W,ACCE
	SUBC		DH,F,ACCE
	MVL		00h
	SUBC		EDL,F,ACCE
	RET

;==============================================================================
;input: EAH/EAL/AH/AL/EBH/EBL/BH/BL(Qơ^,ECH/ECL/CH/CL]ơ^
;output:EBH|EBL|BH|BL|EAH|EAL|AH|AL(kB⪺ӡ^,EDH/EDL/DH/DL(kB⪺lơ^
;============================================================================== 
64bitdiv32bitu:
	MVL		040h			;64bitQ
div32u:
	MVF		BUFFER,F,ACCE	;ݭnB⪺ƽᵹbufferoܶq
	CLRF		DIVEEL
	CLRF		DIVEH			;Mܶq
	CLRF		DIVEL			
	CLRF		DIVH
	CLRF		DIVL
divloop32u:
	CLRF		STATUS
	RLFC		BL,F			;QƪKӦr`i楪Bz,Ӥ]i楪1
	RLFC		BH,F
	RLFC		EBL,F
	RLFC		EBH,F
	RLFC		AL,F
	RLFC		AH,F
	RLFC		EAL,F
	RLFC		EAH,F
	RLFC		DIVL,F		;QƲXȫOsDIVEEL/DIVEH/DIVEL/DIVH/DIVLAýᵹEEDL/EDH/EDL/DH/DL
	RLFC		DIVH,F
	RLFC		DIVEL,F
	RLFC		DIVEH,F
	RLFC		DIVEEL,F
	MVF		DIVL,W,ACCE
	MVF		DL,F,ACCE
	MVF		DIVH,W,ACCE
	MVF		DH,F,ACCE
	MVF		DIVEL,W,ACCE
	MVF		EDL,F,ACCE
	MVF		DIVEH,W,ACCE
	MVF		EDH,F,ACCE
	MVF		DIVEEL,W,ACCE
	MVF		EEDL,F,ACCE
	CALL		EDX_ECX_1		;EEDL/EDH/EDL/DH/DLPECH/ECL/CH/CLۤ
	BTSS		STATUS,C		;EDH/EDL/DH/DLO_j󰣼ECH/ECL/CH/CL(C1hj)
	JMP		DIVLS32U		;EEDL/EDH/EDL/DH/DL<ECH/ECL/CH/CLhP_즸ƬO_Bz
	MVF		DL,W,ACCE		;EEDL/EDH/EDL/DH/DL>ECH/ECL/CH/CL,hƪȭsᵹDIVH/DIVL/DIVEL/DIVEH/DIVEEL
	MVF		DIVL,F,ACCE
	MVF		DH,W,ACCE
	MVF		DIVH,F,ACCE
	MVF		EDL,W,ACCE
	MVF		DIVEL,F,ACCE
	MVF		EDH,W,ACCE
	MVF		DIVEH,F,ACCE
	MVF		EEDL,W,ACCE
	MVF		DIVEEL,F,ACCE
	INF		AL,F			;EDH/EDL/DH/DLL>ECH/ECL/CH/CLAӪm1
DIVLS32U:
	DCSZ		BUFFER,1		;즸ƴ1O_0
	JMP		DIVLOOP32U		;SƾڹBA~iGi찣kB
	CLRF		STATUS		
	MVF		DIVL,W,ACCE	;ƾڳBzAOskB⪺lƩEDH/EDL/DH/DL
	MVF		DL,F,ACCE
	MVF		DIVH,W,ACCE
	MVF		DH,F,ACCE
	MVF		DIVEL,W,ACCE
	MVF		EDL,F,ACCE
	MVF		DIVEH,W,ACCE
	MVF		EDH,F,ACCE
	RET
EDX_ECX_1:
	MVF		CL,W,ACCE		  
	SUBF		DL,F,ACCE
	MVF		CH,W,ACCE		;۴GOsbEDH/EDL/DH/DL
	SUBC		DH,F,ACCE
	MVF		ECL,W,ACCE
	SUBC		EDL,F,ACCE
	MVF		ECH,W,ACCE
	SUBC		EDH,F,ACCE
	MVL		00h
	SUBC		EEDL,F,ACCE
	RET
	
;==================================================
;32bits / 16bits |ˤJ
;==================================================
32DIV16INF:
	CLRF		EDL,ACCE
	BCF		STATUS,C,ACCE
	RLFC		DL,F,ACCE
	RLFC		DH,F,ACCE
	RLFC		EDL,F,ACCE
	MVF		GL,W,ACCE
	SUBF		DL,F,ACCE
	MVF		GH,W,ACCE
	SUBC		DH,F,ACCE
	MVL		00H
	SUBC		EDL,F,ACCE
	BTSZ		STATUS,C,ACCE
	JMP		32DIV16INF_1
	RET
32DIV16INF_1:
	INF		AL,F,ACCE
	BTSS		STATUS,Z,ACCE	
	RET
	INF		AH,F,ACCE
	BTSS		STATUS,Z,ACCE
	RET
	INF		EAL,F,ACCE
	BTSS		STATUS,Z,ACCE
	RET
	INF		EAH,F,ACCE
	RET

;====================================
;64bit / 32bits |ˤJ
;====================================	
64DIV32INF:
	CLRF		EEDL
	BCF		STATUS,C,ACCE
	RLFC		DL,F,ACCE
	RLFC		DH,F,ACCE
	RLFC		EDL,F,ACCE
	RLFC		EDH,F,ACCE
	RLFC		EEDL,F,ACCE
	MVF		GL,W,ACCE
	SUBF		DL,F,ACCE
	MVF		GH,W,ACCE
	SUBC		DH,F,ACCE
	MVF		EGL,W,ACCE
	SUBC		EDL,F,ACCE
	MVF		EGH,W,ACCE
	SUBC		EDH,F,ACCE
	MVL		00H
	SUBC		EEDL,F,ACCE
	BTSZ		STATUS,C,ACCE
	JMP		64DIV32INF_1
	RET
64DIV32INF_1:
	INF		AL,F,ACCE
	BTSS		STATUS,Z,ACCE
	RET
	INF		AH,F,ACCE
	BTSS		STATUS,Z,ACCE
	RET
	INF		EAL,F,ACCE
	BTSS		STATUS,Z,ACCE
	RET
	INF		EAH,F,ACCE
	BTSS		STATUS,Z,ACCE
	RET
	INF		BL,F,ACCE
	BTSS		STATUS,Z,ACCE
	RET
	INF		BH,F,ACCE
	BTSS		STATUS,Z,ACCE
	RET
	INF		EBL,F,ACCE
	BTSS		STATUS,Z,ACCE
	RET
	INF		EBH,F,ACCE
	RET

;======================================
;2416iഫ32BCDXΦ
;Input:EAL|AH|AL, Output:EAH|EAL|AH|AL
;======================================
24BITHEXTOBCD:
	MVL		18H
	MVF		CNT,F,ACCE
BCDINI:
	MVFF		AL,TMP1
	MVFF		AH,TMP2
	MVFF		EAL,TMP3
	CLRF		AL,ACCE		;sBCD|ӱHsEAH/EAL/AH/ALM0
	CLRF		AH,ACCE
	CLRF		EAL,ACCE
	CLRF		EAH,ACCE
	CLRF		STATUS
LOOPC1:
	RLFC		TMP1,F,ACCE
	RLFC		TMP2,F,ACCE
	RLFC		TMP3,F,ACCE
	RLFC		AL,F,ACCE
	RLFC		AH,F,ACCE
	RLFC		EAL,F,ACCE
	RLFC		EAH,F,ACCE
	DCSZ		CNT,F,ACCE
	JMP		ADJDEC1
	RET
ADJDEC1:
	MVL		00H
	MVF		FSR0H,F,ACCE
	MVL		AL
	MVF		FSR0L,F,ACCE
	CALL		ADJBCD1
	MVL		AH
	MVF		FSR0L,F,ACCE
	CALL		ADJBCD1
	MVL		EAL
	MVF		FSR0L,F,ACCE
	CALL		ADJBCD1
	JMP		LOOPC1
ADJBCD1:
	MVL		03H
	ADDF		INDF0,W,ACCE
	MVF		TMP0,F,ACCE
	BTSZ		TMP0,3
	MVF		INDF0,F,ACCE
	MVL		30H
	ADDF		INDF0,W,ACCE
	MVF		TMP0,F,ACCE
	BTSZ		TMP0,7
	MVF		INDF0,F,ACCE
	RET

;-------------EAX|AX D---------------
COMF_EAX:
	CLRF		STATUS,ACCE
	COMF		AL,F,A
	COMF		AH,F,A
	COMF		EAL,F,A
	COMF		EAH,F,A
	INF		AL,F,A
	BTSS		STATUS,Z,A
	RET
	INF		AH,F,A
	BTSS		STATUS,Z,A
	RET
	INF		EAL,F,A
	BTSS		STATUS,Z,A
	RET
	INF		EAH,F,A
	RET
	
COMF_EAX_1:
	BSF		FLAG,SIGN,A
	CLRF		STATUS,A
	COMF		AL,F,A
	COMF		AH,F,A
	INF		AL,F,A
	BTSS		STATUS,Z,A
	RET
	INF		AH,F,A
	RET
	
COMF_AX:
	CLRF		STATUS,A
	COMF		AL,F,A
	COMF		AH,F,A
	INF		AL,F,A
	BTSS		STATUS,Z,A
	RET
	INF		AH,F,A
	RET
	
;-----------EBX|BX ==> EDX|DX------------
EBX_EDX:
	MVFF		EBH,EDH
	MVFF		EBL,EDL
	MVFF		BH,DH
	MVFF		BL,DL
	RET

;-----------EAX|AX ==> EBX|BX------------
EAX_EBX:
	MVFF		EAH,EBH
	MVFF		EAL,EBL
	MVFF		AH,BH
	MVFF		AL,BL
	RET

;-----------EDX|DX ==> EAX|AX------------
EDX_EAX:
	MVFF		EDH,EAH
	MVFF		EDL,EAL
	MVFF		DH,AH
	MVFF		DL,AL
	RET



